
/** Ulozi na urcene misto v poli u16 v Big Endian */
void append_u8(u8 dest[], u16* where, u8 value){
  dest[(*where)++] = (u8)value;
  assert(*where < BUFLEN);
}

/** Ulozi na urcene misto v poli u16 v Big Endian */
void append_u16_BE(u8 dest[], u16* where, u16 value){
  dest[(*where)++] = (u8)(value >> 8);
  dest[(*where)++] = (u8)value;
  assert(*where < BUFLEN);
}
/** Ulozi na urcene misto v poli u16 v Litle Endian */
void append_u16(u8 dest[], u16* where, u16 value){
  dest[(*where)++] = (u8)(value);
  dest[(*where)++] = (u8)(value >> 8);
  assert(*where < BUFLEN);
}
/** Ulozi na urcene misto v poli u32 v Big Endian */
void append_u32_BE(u8 dest[], u16* where, u32 value) {
  dest[(*where)++] = (u8)(value >> 24);
  dest[(*where)++] = (u8)(value >> 16);  
  dest[(*where)++] = (u8)(value >> 8);  
  dest[(*where)++] = (u8)value;
  assert(*where < BUFLEN);
}

/** Ulozi na urcene misto v poli u64 v Big Endian */
void append_u64_BE(u8 dest[], u16* where, u64 value) {
  dest[(*where)++] = (u8)(value >> 56);
  dest[(*where)++] = (u8)(value >> 48);
  dest[(*where)++] = (u8)(value >> 40);
  dest[(*where)++] = (u8)(value >> 32);
  dest[(*where)++] = (u8)(value >> 24);
  dest[(*where)++] = (u8)(value >> 16);  
  dest[(*where)++] = (u8)(value >> 8);  
  dest[(*where)++] = (u8)value;
  assert(*where < BUFLEN);
}

/** Ulozi na urcene misto v poli float v Big Endian */
void append_flo_BE(u8 dest[], u16* where, float value){
  union convert32 conv;
  conv.F  = value;
  dest[(*where)++] = conv.C[3];
  dest[(*where)++] = conv.C[2];
  dest[(*where)++] = conv.C[1];
  dest[(*where)++] = conv.C[0];
  assert(*where < BUFLEN);
}

/** ulozi na urcene misto v poli strukturu TPackedTime */
void append_TPackedTime(u8 dest[], u16* where, TPackedTime array){
  dest[(*where)++] = array.Value.DayMSBMin;
  dest[(*where)++] = array.Value.MonthLSBMin;
  dest[(*where)++] = array.Value.Year;
  dest[(*where)++] = array.Value.Hour;
  assert(*where < BUFLEN);
}

float RandomFloat(int ideal, int odchylka, int pravd)
{
	float nahoda;
   if ((rnd() % 100) < pravd)
   	nahoda = ideal + (rnd() % (2 * ideal * odchylka / 100) - ideal * odchylka / 100);
   else
   	nahoda = rnd();
   nahoda *= 40;
   return nahoda;
}

short unsigned int RandomInt(int ideal, int odchylka, int pravd)
{
	float nahoda;
	short unsigned int hodnota;
   if ((rnd() % 100) < pravd)
   	nahoda = ideal + (rnd() % (2 * ideal * odchylka / 100) - ideal * odchylka / 100);
   else
   	nahoda = rnd();
   nahoda *= 40;
   hodnota = nahoda;
   return hodnota;
}

/* vytvori odpoved na zpravu vrat aktualni data 0x3A. */
void msgGetActData(u8* buf){//TODO otestovat a velikost bufferu
	double ideal;		// Idealni hodnota veliciny
	double nahoda;		// Promenna pro vypocty
	double pravd;		// Pravdepodobnost v procentech
	double odchylka;	// Maximalni odchylka od idealni hodnoty v procentech
  if(_DATA(buf) <4)
    _BAD_LEN(buf)
  else {
    //u32 MsgCfgInt = (buf[4] << 24) | (buf[5] << 16) | (buf[6] << 8) | buf[7];
    u32 MsgCfgInt = ffffh;   
    u16 i = 8; // zachova MsgCfgInt
    /* nejprve nemaskovatelne veliciny */
    //append_u8(&buf[0], &i, getConfigChange());
    append_u8(&buf[0], &i, rnd());         
    //append_u16(&buf[0], &i, status.ErrCode);
    append_u16(&buf[0], &i, rnd());
    // flagy - napr frekvence a podobne ?x u16
    //append_u8(&buf[0], &i, AktualniHodnoty.overfl);
    append_u8(&buf[0], &i, rnd());                
    //append_u8(&buf[0], &i, AktualniHodnoty.underfl);
    append_u8(&buf[0], &i, rnd());                
    //append_u16_BE(&buf[0], &i, AktualniHodnoty.InputOutput );
    append_u16_BE(&buf[0], &i, rnd());
    
    //append_u16_BE(&buf[0], &i, (u16)(AktualniHodnoty.Freq*100.0+0.5));
    append_u16_BE(&buf[0], &i, XXX); 
    //append_u16_BE(&buf[0], &i, AktualniHodnoty.AnalogovaHodnota);
    append_u16_BE(&buf[0], &i, XXX);          
    //append_u16_BE(&buf[0], &i, AktualniHodnoty.iL[4]);
    append_u16_BE(&buf[0], &i, XXX);

/*
    if (MsgCfgInt & (1<<4)) { // predavat ACT Data
      //ULN
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, AktualniHodnoty.uLN[a]);
      //ULL
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, AktualniHodnoty.uLL[a]);
      //IL
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, AktualniHodnoty.iL[a]);                
      //PWR
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_flo_BE(&buf[0], &i, AktualniHodnoty.pwr[a]);                
      //PWR 1. harm
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_flo_BE(&buf[0], &i, AktualniHodnoty.pwrf[a]);                
      //VAR
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) appendint_flo_BE(&buf[0], &i, AktualniHodnoty.var[a]);                
      //VAR 1. harm
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_flo_BE(&buf[0], &i, AktualniHodnoty.varf[a]);                
      //Pavg 1/4h
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_flo_BE(&buf[0], &i, AktualniHodnoty.Pavg[a]);                      
      //uTHD
      for(int a=0;a<4;a++) 
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, AktualniHodnoty.uTHD[a]);                
      //iTHD
      for(int a=0;a<4;a++) 
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, AktualniHodnoty.iTHD[a]);                
    } //act data
*/    

    if (MsgCfgInt & (1<<4)) { // predavat ACT Data
      //ULN
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, RandomInt(230,10,95));
      //ULL
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, RandomInt(400,10,95));
      //IL
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, RandomInt(100,100,100));                
      //PWR
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_flo_BE(&buf[0], &i, (float)nahoda);                
      //PWR 1. harm
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_flo_BE(&buf[0], &i, (float)nahoda);                
      //VAR
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_flo_BE(&buf[0], &i, (float)nahoda);                
      //VAR 1. harm
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_flo_BE(&buf[0], &i, (float)nahoda);                
      //Pavg 1/4h
      for(int a=0;a<4;a++)
        if(MsgCfgInt & (1<<a)) append_flo_BE(&buf[0], &i, (float)nahoda);                      
      //uTHD
      for(int a=0;a<4;a++) 
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, (u16)nahoda);                
      //iTHD
      for(int a=0;a<4;a++) 
        if(MsgCfgInt & (1<<a)) append_u16_BE(&buf[0], &i, (u16)nahoda);                
    } //act data
  
    //harm
    u8 HarmonicCount = ((MsgCfgInt & 0xFC00)>>10)+1;// dekodovany pocet harmonickych
    
    if(MsgCfgInt & (1<<5)){  // harm. U
      for(int a=0;a<4;a++){
        float fstHarm = AktualniHodnoty.HsgU[a][0] / 4000; // kvuli prevodu na %

        if (MsgCfgInt & (1<<a)) {
          for(int j=0;j<HarmonicCount;j++){
            if (((j % 2) == 0)                                   /* Liche */
              || (((j % 2) == 1) && ((MsgCfgInt & (1<<9)))))      /* Sude */
              append_u16_BE(&buf[0], &i, (u16)((AktualniHodnoty.HsgU[a][j]/fstHarm)+0.5));   
          }
        }
      }
    } //konec:harm U
    
    if(MsgCfgInt & (1<<6)){ // harm. I
      for(int a=0;a<4;a++){
        float kalibrace = KalibracniI*5000.0*SQRT_2;
        if (MsgCfgInt & (1<<a)) {
          for(int j=0;j<HarmonicCount;j++){
            if (((j % 2) == 0)                                   /* Liche */
              || (((j % 2) == 1) && ((MsgCfgInt & (1<<9)))))      /* Sude */
              append_u16_BE(&buf[0], &i, (u16)(AktualniHodnoty.HsgI[a][j]*kalibrace+0.5));     
          }
        }
      }
    }//konec:harm I

    //meziharm 
    
    if(MsgCfgInt & (1<<7)){  // meziharm. U
      for(int a=0;a<4;a++){
        float fstHarm = AktualniHodnoty.HsgU[a][0] / 4000; // kvuli prevodu na %

        if (MsgCfgInt & (1<<a)) {
          for(int j=0;j<HarmonicCount;j++){
            if (((j % 2) == 0)                                   /* Liche */
              || (((j % 2) == 1) && ((MsgCfgInt & (1<<9)))))      /* Sude */
              append_u16_BE(&buf[0], &i, (u16)((AktualniHodnoty.HsgU[a][j]/fstHarm)+0.5));   
          }
        }
      }
    } //konec:meziharm U
    
    if(MsgCfgInt & (1<<8)){ // meziharm. I
      for(int a=0;a<4;a++){
        float kalibrace = KalibracniI*5000.0*SQRT_2;
        if (MsgCfgInt & (1<<a)) {
          for(int j=0;j<HarmonicCount;j++){
            if (((j % 2) == 0)                                   /* Liche */
              || (((j % 2) == 1) && ((MsgCfgInt & (1<<9)))))      /* Sude */
              append_u16_BE(&buf[0], &i, (u16)(AktualniHodnoty.HsgI[a][j]*kalibrace+0.5));      
          }
        }
      }
    }//konec:meziharm I
}
